#ifndef WINDOW_H
#define WINDOW_H

#include "c_cpp_aliases/aliases.h"
#include <SDL2/SDL_video.h>
#include <stdbool.h>

typedef struct {
  u8 r;
  u8 g;
  u8 b;
  u8 a;
} colour_t;

typedef struct {
  u64 width;
  u64 height;
  const char *title;
  SDL_Window *window;
  SDL_Surface *front_buffer;
  SDL_Surface *back_buffer;
} window_t;

bool init_window(window_t *wnd, u64 width, u64 height, const char *title);
void close_window(window_t *wnd);

void clear_window(window_t *wnd, colour_t colour);
void set_pixel(window_t *wnd, f32 x, f32 y, colour_t colour);
void swap_buffers(window_t *wnd);

#endif // !WINDOW_H
